Index: java/main/src/main/java/com/framsticks/gui/TreeNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 97)
@@ -1,9 +1,9 @@
 package com.framsticks.gui;
 
-import com.framsticks.communication.Connection;
 import com.framsticks.communication.Subscription;
 import com.framsticks.communication.util.LoggingStateCallback;
-import com.framsticks.core.Instance;
-import com.framsticks.core.InstanceUtils;
+import com.framsticks.core.Mode;
+import com.framsticks.core.Tree;
+import com.framsticks.core.TreeOperations;
 import com.framsticks.core.ListChange;
 import com.framsticks.core.Path;
@@ -18,6 +18,7 @@
 import com.framsticks.util.lang.Holder;
 import com.framsticks.util.swing.TooltipConstructor;
-import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.AbstractStateFunctor;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Logging;
 import org.apache.log4j.Logger;
@@ -31,5 +32,5 @@
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 import com.framsticks.util.swing.TreeNodeUtils;
-import static com.framsticks.core.InstanceUtils.*;
+import static com.framsticks.core.TreeOperations.*;
 
 /**
@@ -37,5 +38,5 @@
  */
 @SuppressWarnings("serial")
-public class TreeNode extends DefaultMutableTreeNode implements NodeListener {
+public class TreeNode extends DefaultMutableTreeNode implements NodeListener, ExceptionResultHandler {
 
 	private static final Logger log = Logger.getLogger(TreeNode.class.getName());
@@ -44,5 +45,5 @@
 
 	final protected Frame frame;
-	final protected InstanceAtFrame instanceAtFrame;
+	final protected TreeAtFrame treeAtFrame;
 
 	final protected Map<EventParam, Subscription<?>> userSubscriptions = new HashMap<>();
@@ -50,22 +51,22 @@
 	protected String tooltip;
 	protected String name;
-	protected final String paramId;
+	protected final CompositeParam param;
 	protected String iconName;
 	protected Path path;
 
-	public TreeNode(InstanceAtFrame instanceAtFrame, final Path path) {
-		this.frame = instanceAtFrame.getFrame();
-		assert frame.isActive();
-		this.paramId = path.getLastElement();
-		this.name = this.paramId;
+	public TreeNode(TreeAtFrame treeAtFrame, final Path path) {
+		this.frame = treeAtFrame.getFrame();
+		assert frame.isActive();
+		this.param = path.getTop().getParam();
+		this.name = this.param.getId();
 		log.debug("creating treenode " + name + ": " + path);
 		this.path = path;
-		this.instanceAtFrame = instanceAtFrame;
+		this.treeAtFrame = treeAtFrame;
 
 		iconName = TreeCellRenderer.findIconName(name, path.getTextual());
 		tooltip = "?";
-		path.getInstance().dispatch(new RunAt<Instance>() {
-			@Override
-			public void run() {
+		path.getTree().dispatch(new RunAt<Tree>(this) {
+			@Override
+			protected void runAt() {
 				updateDescriptions(path);
 			}
@@ -74,10 +75,10 @@
 
 	public void fetch(final Path p) {
-		assert p.getInstance().isActive();
+		assert p.getTree().isActive();
 		log.debug("fetching: " + p);
-		p.getInstance().fetchValues(p, new AbstractStateFunctor() {
-			@Override
-			public void call() {
-				// reactForFetchResult(p, e);
+		p.getTree().get(p, Mode.FETCH, new FutureHandler<Object>(this) {
+			@Override
+			protected void result(Object result) {
+
 			}
 		});
@@ -85,9 +86,9 @@
 
 	protected void reactForFetchResult(final Path p, Exception e) {
-		assert p.getInstance().isActive();
+		assert p.getTree().isActive();
 		if (Logging.log(log, "fetch", TreeNode.this, e)) {
-			frame.dispatch(new RunAt<Frame>() {
+			frame.dispatch(new RunAt<Frame>(this) {
 				@Override
-				public void run() {
+				protected void runAt() {
 					log.debug("removing node from tree: " + p);
 					frame.treeModel.removeNodeFromParent(TreeNode.this);
@@ -97,7 +98,7 @@
 		}
 		updateChildren(p);
-		frame.dispatch(new RunAt<Frame>() {
-			@Override
-			public void run() {
+		frame.dispatch(new RunAt<Frame>(this) {
+			@Override
+			protected void runAt() {
 				//TODO maybe this should be called from some better place
 				useOrCreatePanel();
@@ -109,7 +110,7 @@
 		assert !frame.isActive();
 		/** TODO those two actions could be merged into single closure */
-		frame.dispatch(new RunAt<Frame>() {
-			@Override
-			public void run() {
+		frame.dispatch(new RunAt<Frame>(this) {
+			@Override
+			protected void runAt() {
 				updatePath(newPath);
 			}
@@ -140,10 +141,7 @@
 	 */
 	protected void updateChildren(final Path p) {
-		assert p.getInstance().isActive();
+		assert p.getTree().isActive();
 		log.debug("updating children of " + this);
-		AccessInterface access = InstanceUtils.bindAccess(p.getInstance(), p.getTop());
-		if (access == null) {
-			return;
-		}
+		AccessInterface access = TreeOperations.bindAccess(p.getTree(), p.getTop());
 		final List<Path> childrenPaths = new LinkedList<Path>();
 		/**Prepare path for each child.*/
@@ -154,7 +152,7 @@
 		/**If some child were found, update in frame context.*/
 		if (childrenPaths.size() > 0) {
-			frame.dispatch(new RunAt<Frame>() {
+			frame.dispatch(new RunAt<Frame>(this) {
 				@Override
-				public void run() {
+				protected void runAt() {
 					// TreePath treePath = frame.startChange();
 					updatePath(p);
@@ -173,5 +171,5 @@
 						}
 						log.debug("update: treenode for " + p);
-						TreeNode childNode = new TreeNode(instanceAtFrame, childPath);
+						TreeNode childNode = new TreeNode(treeAtFrame, childPath);
 
 						frame.addNode(childNode, TreeNode.this);
@@ -191,7 +189,7 @@
 		final Path p = path;
 
-		p.getInstance().dispatch(new RunAt<Instance>() {
-			@Override
-			public void run() {
+		p.getTree().dispatch(new RunAt<Tree>(this) {
+			@Override
+			protected void runAt() {
 				final Path updated = (p.isResolved()) ? p : p.tryFindResolution();
 				if (updated.isResolved()) {
@@ -201,5 +199,5 @@
 					return;
 				}
-				p.getInstance().resolve(updated, new Future<Path>(Logging.logger(log, "resolve and select", TreeNode.this)) {
+				p.getTree().resolve(updated, new FutureHandler<Path>(Logging.logger(log, "resolve and select", TreeNode.this)) {
 					@Override
 					protected void result(Path result) {
@@ -224,27 +222,19 @@
 
 	protected void updateDescriptions(Path p) {
-		assert p.getInstance().isActive();
+		assert p.getTree().isActive();
 
 		if (!p.isResolved()) {
 			return;
 		}
-		AccessInterface access = InstanceUtils.bindAccess(p);
-
-		final String tooltip = new TooltipConstructor()
-			.append("frams", access.getId())
-			.append("java", p.getTopObject().getClass().getCanonicalName())
-			.append("access", access.getClass().getSimpleName())
-			.append("name", name)
-			.append("id", paramId)
-			.append("object", Integer.toHexString(System.identityHashCode(this)))
-			.build()
-			;
+		AccessInterface access = TreeOperations.bindAccess(p);
+
+		final String tooltip = new TooltipConstructor().append("frams", access.getId()).append("java", p.getTopObject().getClass().getCanonicalName()).append("access", access.getClass().getSimpleName()).append("name", name).append("id", param.getId()).append("object", Integer.toHexString(System.identityHashCode(this))).build();
 
 		StringParam nameParam = Casting.tryCast(StringParam.class, access.getParam("name"));
 		final String name = (nameParam != null ? access.get(nameParam, String.class) : path.getTop().getParam().getId());
 
-		frame.dispatch(new RunAt<Frame>() {
-			@Override
-			public void run() {
+		frame.dispatch(new RunAt<Frame>(this) {
+			@Override
+			protected void runAt() {
 				TreeNode.this.tooltip = tooltip;
 				TreeNode.this.name = name;
@@ -254,36 +244,4 @@
 		});
 	}
-
-/*
-	public void updateData() {
-		assert browser.isActive();
-		final Node node = getNode();
-		browser.manager.invokeLater(new Runnable() {
-			@Override
-			public void run() {
-				node.fetchValues(new StateFunctor() {
-					@Override
-					public void call(Exception e) {
-						if (e != null) {
-							return;
-						}
-						browser.invokeLater(new Runnable() {
-							@Override
-							public void run() {
-								assert browser.isActive();
-								if (panel.getCurrentTreeNode() == TreeNode.this) {
-									panel.refreshComponents();
-								}
-
-								browser.tree.repaint();
-								panel.refreshComponents();
-							}
-						});
-					}
-				});
-			}
-		});
-	}
-*/
 
 	public void showPanel() {
@@ -301,13 +259,13 @@
 		assert p.isResolved();
 		panel.setCurrentTreeNode(this);
-		p.getInstance().dispatch(new RunAt<Instance>() {
-			@Override
-			public void run() {
-				AccessInterface access = InstanceUtils.bindAccess(p);
+		p.getTree().dispatch(new RunAt<Tree>(this) {
+			@Override
+			protected void runAt() {
+				AccessInterface access = TreeOperations.bindAccess(p);
 				panel.pullValuesFromLocalToUser(access);
 
-				frame.dispatch(new RunAt<Frame>() {
+				frame.dispatch(new RunAt<Frame>(this) {
 					@Override
-					public void run() {
+					protected void runAt() {
 						showPanel();
 					}
@@ -331,5 +289,5 @@
 
 		CompositeParam param = path.getTop().getParam();
-		panel = instanceAtFrame.findPanel(param.computeAccessId());
+		panel = treeAtFrame.findPanel(param.computeAccessId());
 		if (panel != null) {
 			log.debug("found prepared panel for: " + path);
@@ -339,14 +297,14 @@
 		final Path p = path;
 		log.debug("preparing panel: " + p);
-		p.getInstance().dispatch(new RunAt<Instance>() {
-			@Override
-			public void run() {
-				assert p.getInstance().isActive();
+		p.getTree().dispatch(new RunAt<Tree>(this) {
+			@Override
+			protected void runAt() {
+				assert p.getTree().isActive();
 				final CompositeParam param = p.getTop().getParam();
-				final FramsClass framsClass = p.getInstance().getInfoFromCache(param.getContainedTypeName());
-				frame.dispatch(new RunAt<Frame>() {
+				final FramsClass framsClass = p.getTree().getInfoFromCache(param.getContainedTypeName());
+				frame.dispatch(new RunAt<Frame>(this) {
 					@Override
-					public void run() {
-						panel = instanceAtFrame.preparePanel(param, framsClass);
+					protected void runAt() {
+						panel = treeAtFrame.preparePanel(param, framsClass);
 						fillPanelWithValues();
 					}
@@ -360,7 +318,4 @@
 		return tooltip;
 	}
-
-
-
 
 	/*public void subscribe(final EventParam eventParam) {
@@ -408,46 +363,43 @@
 			return;
 		}
-		userSubscriptions.get(eventParam).unsubscribe(new LoggingStateCallback<Connection>(log, "unsubscribed " + eventParam));
+		userSubscriptions.get(eventParam).unsubscribe(new LoggingStateCallback(log, "unsubscribed " + eventParam));
 		userSubscriptions.remove(eventParam);
 	}
 
-/*
-
-	@Override
-	public void onChildChange(final Child child, ListChange.Action action) {
-		assert browser.manager.isActive();
-
-		switch (action) {
-			case Remove: {
-				Dispatching.invokeDispatch(browser, browser.manager, new Runnable() {
-					@Override
-					public void run() {
-						assert browser.manager.isActive();
-						final TreeNode treeNode = (TreeNode) child.getUserObject();
-						if (treeNode == null) {
-							log.error("child " + child + " had no tree node attached");
-							return;
-						}
-						browser.invokeLater(new Runnable() {
-							@Override
-							public void run() {
-								assert browser.isActive();
-								TreePath path = browser.startChange();
-								//assert treeNode.getParent() == TreeNode.this;
-								if (treeNode.getParent() != null) {
-									browser.treeModel.removeNodeFromParent(treeNode);
-								}
-								//remove(treeNode);
-								browser.markNodeChanged(TreeNode.this, path);
-							}
-						});
-					}
-				});
-				break;
-			}
-		}
-
-	}
-*/
+	// @Override
+	// public void onChildChange(final Child child, ListChange.Action action) {
+	// assert browser.manager.isActive();
+
+	// switch (action) {
+	// case Remove: {
+	// Dispatching.invokeDispatch(browser, browser.manager, new Runnable() {
+	// @Override
+	// public void run() {
+	// assert browser.manager.isActive();
+	// final TreeNode treeNode = (TreeNode) child.getUserObject();
+	// if (treeNode == null) {
+	// log.error("child " + child + " had no tree node attached");
+	// return;
+	// }
+	// browser.invokeLater(new Runnable() {
+	// @Override
+	// public void run() {
+	// assert browser.isActive();
+	// TreePath path = browser.startChange();
+	// //assert treeNode.getParent() == TreeNode.this;
+	// if (treeNode.getParent() != null) {
+	// browser.treeModel.removeNodeFromParent(treeNode);
+	// }
+	// //remove(treeNode);
+	// browser.markNodeChanged(TreeNode.this, path);
+	// }
+	// });
+	// }
+	// });
+	// break;
+	// }
+	// }
+
+	// }
 
 	public String getName() {
@@ -486,5 +438,5 @@
 	}
 
-	public Path getInstancePath() {
+	public Path getTreePath() {
 		assert frame.isActive();
 		return path;
@@ -501,8 +453,8 @@
 		final Path p = path;
 
-		for (Map.Entry<ValueControl, Object> e : localChanges.entrySet()) {
-			storeValue(p, e.getKey().getParam(), e.getValue(), new AbstractStateFunctor() {
+		for (Map.Entry<ValueControl, Object> e : changes.entrySet()) {
+			set(p, e.getKey().getParam(), e.getValue(), new FutureHandler<Integer>(this) {
 				@Override
-				public void call() {
+				protected void result(Integer flag) {
 					counter.set(counter.get() - 1);
 					if (counter.get() != 0) {
@@ -510,13 +462,19 @@
 					}
 					log.debug("applied changes for: " + p);
-					frame.dispatch(new RunAt<Frame>() {
+					frame.dispatch(new RunAt<Frame>(this) {
 						@Override
-						public void run() {
+						protected void runAt() {
 							fillPanelWithValues();
 						}
 					});
 				}
+
 			});
 		}
 	}
+
+	@Override
+	public void handle(FramsticksException exception) {
+		frame.handle(exception);
+	}
 }
Index: java/main/src/main/java/com/framsticks/gui/console/Console.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/Console.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/console/Console.java	(revision 97)
@@ -0,0 +1,136 @@
+package com.framsticks.gui.console;
+
+import java.awt.BorderLayout;
+import java.awt.Dimension;
+
+import javax.swing.BorderFactory;
+import javax.swing.JPanel;
+import javax.swing.JScrollPane;
+import javax.swing.JTextPane;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.communication.Connection;
+import com.framsticks.gui.FrameJoinable;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.dispatching.RunAt;
+
+@FramsClassAnnotation
+public abstract class Console extends FrameJoinable implements JoinableParent {
+	private static final Logger log = Logger.getLogger(Console.class);
+
+	/**
+	 * Painter coloring manager responses before display.
+	 */
+	protected ConsolePainter consolePainter;
+
+	protected Connection connection;
+
+	protected JPanel panel;
+
+	/**
+	 * @param connection
+	 */
+	public Console() {
+		setTitle("console");
+	}
+
+	/**
+	 * @return the connection
+	 */
+	public Connection getConnection() {
+		return connection;
+	}
+
+	@Override
+	public String getName() {
+		return connection != null ? "console for " + connection.getName() : "console";
+	}
+
+	@Override
+	protected void initializeGui() {
+		super.initializeGui();
+		panel = new JPanel();
+		panel.setLayout(new BorderLayout());
+		panel.setSize(new Dimension(440, 400));
+		panel.setMinimumSize(new Dimension(440, 400));
+
+		JTextPane text = new JTextPane();
+		consolePainter = new ConsolePainter(text);
+
+		text.setEditable(false);
+		final JScrollPane scrollText = new JScrollPane(text);
+		scrollText.setBorder(BorderFactory.createEtchedBorder());
+
+		JPanel scrollPanel = new JPanel();
+		scrollPanel.setLayout(new BorderLayout());
+		scrollPanel.add(scrollText, BorderLayout.CENTER);
+		scrollPanel.setBorder(BorderFactory.createEmptyBorder(7, 7, 7, 7));
+
+		panel.add(scrollPanel, BorderLayout.CENTER);
+
+		getSwing().getContentPane().add(panel, BorderLayout.CENTER);
+
+		log.debug("initialized gui");
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		if (joinable == connection) {
+			proceedToState(state);
+		}
+	}
+
+	protected ExceptionResultHandler getExceptionHandler() {
+		return new ExceptionResultHandler() {
+
+			@Override
+			public void handle(FramsticksException exception) {
+				throw exception;
+
+			}
+		};
+	}
+
+	@Override
+	protected void joinableStart() {
+		if (connection == null) {
+			throw new FramsticksException().msg("connection was not set").arg("console", this);
+		}
+		super.joinableStart();
+		Dispatching.use(connection, this);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(connection, this);
+		super.joinableInterrupt();
+	}
+
+	@Override
+	protected void joinableFinish() {
+		super.joinableFinish();
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(connection);
+		super.joinableJoin();
+	}
+
+	protected void dispatchWrite(final String line) {
+		dispatch(new RunAt<Console>(getExceptionHandler()) {
+			@Override
+			protected void runAt() {
+				consolePainter.userLine(line);
+			}
+		});
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/console/ConsolePainter.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/ConsolePainter.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/console/ConsolePainter.java	(revision 97)
@@ -0,0 +1,211 @@
+package com.framsticks.gui.console;
+
+import com.framsticks.communication.File;
+import com.framsticks.util.FramsticksException;
+// import org.apache.log4j.Logger;
+
+// import java.awt.Color;
+
+import javax.swing.JTextPane;
+import javax.swing.text.BadLocationException;
+import javax.swing.text.Document;
+import javax.swing.text.SimpleAttributeSet;
+
+/**
+ * Class paints messages.
+ */
+public class ConsolePainter {
+	// private static final Logger log = Logger.getLogger(ConsolePainter.class.getName());
+
+	private final Document doc;
+	private final JTextPane textPane;
+	// private Color c1 = new Color(192, 0, 0);
+	// private Color c2 = new Color(84, 141, 212);
+	// private Color c3 = new Color(118, 146, 60);
+	// private Color c4 = new Color(0, 0, 128);
+	// private final SimpleLinePainter linePainter1;
+	// private final SimpleLinePainter linePainter2;
+	private final SimpleAttributeSet set = new SimpleAttributeSet();
+
+
+	/**
+	 * Constructor sets reference to pane with text.
+	 * @param pane Pane where text is displaying.
+	 */
+	public ConsolePainter(JTextPane pane) {
+		this.textPane = pane;
+		doc = textPane.getStyledDocument();
+		// linePainter1 = new SimpleLinePainter(textPane, new Color(224, 224, 255));
+		// linePainter2 = new SimpleLinePainter(textPane, new Color(240, 240, 255));
+	}
+
+	/**
+	 * Paints message.
+	 */
+	public void paintMessage(File file) {
+
+
+		String line;
+		// Boolean boldNextId = false;
+		// Boolean doNotPaint = false;
+
+		while ((line = file.getContent().readLine()) != null) {
+			paintLine(line + "\n");
+			/*
+			if (doNotPaint) {
+				plainText(line);
+				if (line.endsWith("~\n")) {
+					doNotPaint = false;
+				}
+				continue;
+			}
+
+			int indColon = line.indexOf(':');
+
+			if (indColon == -1) {
+				String word = firstWord(line);
+				String rest = line.substring(word.length());
+				Color col = c1;
+
+				if (word.startsWith("ok")) {
+					col = Color.BLACK;
+				} else if (word.startsWith("error")) {
+					col = Color.RED;
+				}
+
+				paintLine(word, col, "b");
+				paintLine(rest, Color.BLACK, "b");
+				continue;
+			}
+
+			if (indColon == line.length() - 2) {
+				String before = line.substring(0, indColon);
+				String type = "b";
+
+				if (before.equals("class")) {
+					boldNextId = true;
+				}
+
+				paintLine(before + ":", c2, type);
+				paintLine("\n", Color.BLACK, "");
+				continue;
+			}
+			String before = line.substring(0, indColon);
+			String after = line.substring(indColon + 1);
+
+			String type;
+
+			if (before.equals("id") && boldNextId) {
+				type = "b";
+				boldNextId = false;
+			} else {
+				type = "";
+			}
+
+			paintLine(before + ":", c3, "b");
+			paintLine(after, Color.BLACK, type);
+
+			if (after.startsWith("~")) {
+				doNotPaint = true;
+			}*/
+
+		}
+
+		scrollDown();
+
+	}
+
+	private void paintLine(String text) {
+		//TODO colouring output, maybe using parsers?
+		try {
+			doc.insertString(doc.getLength(), text, set);
+		} catch (BadLocationException e) {
+			throw new FramsticksException().msg("failed document insertion").cause(e);
+		}
+	}
+	/**
+	 * Paints line of text.
+	 * @param text Line of text to be painted.
+	 * @param color Font color.
+	 * @param type Font attributes [b|i|u] (bold | italic | underline)
+	 */
+	/*
+	private void paintLine(String text, Color color, String type) {
+		SimpleAttributeSet set = new SimpleAttributeSet();
+
+		if (type.contains("b")) {
+			StyleConstants.setBold(set, true);
+		}
+
+		if (type.contains("i")) {
+			StyleConstants.setItalic(set, true);
+		}
+
+		if (type.contains("u")) {
+			StyleConstants.setUnderline(set, true);
+		}
+
+		StyleConstants.setFontFamily(set, "Monospaced");
+		StyleConstants.setForeground(set, color);
+		textPane.setCharacterAttributes(set, true);
+
+		try {
+			doc.insertString(doc.getLength(), text, set);
+		} catch (BadLocationException e) {
+			e.printStackTrace();
+		}
+
+	}
+	*/
+
+
+
+	/**
+	 * Returns first word in text line.
+	 * @param line Line of text.
+	 * @return First word in text line (with space char).
+	 */
+	// private String firstWord(String line) {
+	// 	String result;
+	// 	int spaceIndex = line.indexOf(' ');
+
+	// 	if (spaceIndex == -1) {
+	// 		result = line;
+	// 	} else {
+	// 		result = line.substring(0, spaceIndex + 1);
+	// 	}
+
+	// 	return result;
+	// }
+
+	/**
+	 * Paint line as plain text.
+	 * @param msg
+	 */
+	/*
+	private void plainText(String msg) {
+		paintLine(msg, Color.BLACK, "");
+	}
+	*/
+
+	/**
+	 * Adds message typed by user.
+	 * @param msg Message typed by user.
+	 */
+	public void userLine(String line) {
+		// paintLine("[USER]> "/*, c4, "b"*/);
+		scrollDown();
+		// linePainter1.resetHighlight();
+		paintLine(line);
+		paintLine("\n");
+		scrollDown();
+	}
+
+	/**
+	 * Scrolling text pane.
+	 */
+	private void scrollDown() {
+		// textPane.setCaretPosition(doc.getLength() - 1);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/console/DirectConsole.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/DirectConsole.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/console/DirectConsole.java	(revision 97)
@@ -0,0 +1,75 @@
+package com.framsticks.gui.console;
+
+import java.util.LinkedList;
+import java.util.List;
+
+import com.framsticks.communication.ClientSideRawConnection;
+import com.framsticks.communication.ConnectionListener;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
+@FramsClassAnnotation
+public class DirectConsole extends InteractiveConsole implements ConnectionListener {
+
+	/**
+	 * @param connection
+	 */
+	public DirectConsole() {
+	}
+
+	@AutoAppendAnnotation
+	public DirectConsole setConnection(ClientSideRawConnection connection) {
+		this.connection = connection;
+		return this;
+	}
+
+	/**
+	 * @return the connection
+	 */
+	@Override
+	public ClientSideRawConnection getConnection() {
+		return (ClientSideRawConnection) connection;
+	}
+
+
+	protected void sendImplementation(String line) {
+		getConnection().send(line, ThrowExceptionHandler.getInstance());
+	}
+
+	/**
+	 * Creates commands tip list.
+	 * @param startText Text that user typed.
+	 */
+	protected void findCompletionPropositions(String prefix) {
+		List<String> propositions = new LinkedList<String>();
+		for (String entry : history) {
+			if (entry.startsWith(prefix)) {
+				propositions.add(entry);
+			}
+		}
+		processCompletionResult(prefix, propositions);
+	}
+
+	@Override
+	protected void joinableStart() {
+		super.joinableStart();
+		connection.getListeners().add(this);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		connection.getListeners().remove(this);
+		super.joinableInterrupt();
+	}
+
+	@Override
+	public void connectionOutgoing(String line) {
+		dispatchWrite(line);
+	}
+
+	@Override
+	public void connectionIncomming(String line) {
+		dispatchWrite(line);
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java	(revision 97)
@@ -0,0 +1,121 @@
+package com.framsticks.gui.console;
+
+import java.util.LinkedList;
+import java.util.List;
+
+
+import com.framsticks.communication.ClientSideManagedConnection;
+import com.framsticks.communication.ClientSideResponseFuture;
+import com.framsticks.communication.File;
+import com.framsticks.communication.Request;
+import com.framsticks.communication.Response;
+import com.framsticks.communication.queries.ApplicationRequest;
+import com.framsticks.core.Path;
+import static com.framsticks.core.TreeOperations.*;
+import com.framsticks.gui.SwingDispatcher;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.remote.RemoteTree;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Containers;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
+
+@FramsClassAnnotation
+public class ManagedConsole extends InteractiveConsole {
+
+	protected RemoteTree tree;
+
+	/**
+	 * @param connection
+	 */
+	public ManagedConsole() {
+	}
+
+	/**
+	 * @return the connection
+	 */
+	@Override
+	public ClientSideManagedConnection getConnection() {
+		return (ClientSideManagedConnection) connection;
+	}
+
+	protected void sendImplementation(String line) {
+		if (!connection.isConnected()) {
+			throw new FramsticksException().msg("not connected").arg("console", this);
+		}
+		//Move that to managed connection
+		ApplicationRequest request;
+		try {
+			Pair<String, String> command = Strings.splitIntoPair(line, ' ', "");
+			request = Casting.throwCast(ApplicationRequest.class, Request.createRequestByTypeString(command.first));
+			request.parseRest(command.second);
+		} catch (FramsticksException e) {
+			throw new FramsticksException().msg("invalid line").arg("line", line).cause(e);
+		}
+
+		paintLine(line);
+
+		getConnection().send(request, SwingDispatcher.getInstance(), new ClientSideResponseFuture(this) {
+			@Override
+			protected void processOk(Response response) {
+				for (File f : response.getFiles()) {
+					consolePainter.paintMessage(f);
+				}
+			}
+		});
+	}
+
+	@Override
+	protected void findCompletionPropositions(final String prefix) {
+		Pair<CharSequence, CharSequence> command = Request.takeIdentifier(prefix);
+
+		Casting.throwCast(ApplicationRequest.class, Request.createRequestByTypeString(command.first.toString()));
+		// Pair<String, String> rest = Strings
+		Pair<CharSequence, CharSequence> rest = Request.takeIdentifier(command.second);
+		if (rest == null) {
+			List<String> propositions = new LinkedList<String>();
+			propositions.add(command.first.toString() + " /");
+			processCompletionResult(prefix, propositions);
+			return;
+		}
+
+		final String textual = rest.first.toString();
+		if (!textual.startsWith("/")) {
+			throw new FramsticksException().msg("invalid line").arg("line", prefix);
+		}
+		// final Iterator<String> iterator = Path.splitPath(textual);
+
+		resolve(tree, textual, new FutureHandler<Path>(this) {
+
+			@Override
+			protected void result(Path path) {
+				if (!textual.startsWith(path.getTextual())) {
+					throw new FramsticksException().msg("invalid state").arg("line", prefix).arg("path", path);
+				}
+
+				List<String> propositions = new LinkedList<String>();
+				String remaining = textual.substring(path.getTextual().length());
+				remaining = Path.PathBuilder.splitPath(remaining).next();
+
+				for (CompositeParam p : Containers.filterInstanceof(bindAccess(path).getParams(), CompositeParam.class)) {
+					if (p.getId().startsWith(remaining)) {
+						propositions.add(p.getId());
+					}
+				}
+				processCompletionResult(prefix, propositions);
+			}
+		});
+
+
+	}
+
+	@AutoAppendAnnotation
+	public void setTree(RemoteTree tree) {
+		this.tree = tree;
+		connection = tree.getConnection();
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/console/SimpleLinePainter.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/SimpleLinePainter.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/console/SimpleLinePainter.java	(revision 97)
@@ -0,0 +1,70 @@
+package com.framsticks.gui.console;
+
+import javax.swing.text.*;
+import java.awt.*;
+
+/**
+ * Painter class to coloring text background.
+ */
+public class SimpleLinePainter extends
+		DefaultHighlighter.DefaultHighlightPainter {
+
+	private JTextComponent component;
+	private DefaultHighlighter highlighter;
+
+	/**
+	 * Constructor sets component reference.
+	 *
+	 * @param component Reference to painted component.
+	 * @param color     Background color.
+	 */
+	public SimpleLinePainter(JTextComponent component, Color color) {
+		super(color);
+
+		this.component = component;
+
+		highlighter = (DefaultHighlighter) component.getHighlighter();
+		highlighter.setDrawsLayeredHighlights(true);
+	}
+
+	/**
+	 * Adds highlight in line sets by offset.
+	 *
+	 * @param offset Line offset.
+	 */
+	public void addHighlight(int offset) {
+		try {
+			highlighter.addHighlight(offset, offset + 1, this);
+		} catch (BadLocationException ignored) {
+		}
+	}
+
+	/**
+	 * Resets highlight.
+	 */
+	public void resetHighlight() {
+
+		Element root = component.getDocument().getDefaultRootElement();
+		int line = root.getElementIndex(component.getCaretPosition());
+		Element lineElement = root.getElement(line);
+		int start = lineElement.getStartOffset();
+		addHighlight(start);
+	}
+
+
+	public Shape paintLayer(Graphics g, int offs0, int offs1, Shape bounds,
+							JTextComponent c, View view) {
+		try {
+			Rectangle r = c.modelToView(offs0);
+			r.x = 0;
+			r.width = c.getSize().width;
+
+			g.setColor(getColor());
+			g.fillRect(r.x, r.y, r.width, r.height);
+			return r;
+		} catch (BadLocationException e) {
+			return null;
+		}
+	}
+
+}
